<template src="./template.html"></template>

<script lang="ts">
import { getModule } from "nuxt-property-decorator";
import { Vue, Component, Prop, Watch } from "vue-property-decorator";
import CountryFlag from "vue-country-flag";
import axios from "axios";
import { apiErrorHandler, redirectPage } from "@/utils/apiHanlers";
import { api, api_key_tiny_editor } from "~/common/constaint";
import _, { cloneDeep } from "lodash";
@Component({})
export default class AdminSettingsPaymentComponent extends Vue {
  api_key_tiny_editor = api_key_tiny_editor;

  paymentId = "";
  paymentDetail = {};
  tab = 0;
  loading = false;
  loadingDelete = false;

  dialogRemovePayment = false;

  listPaymentType = [
    { name: "Stripe", value: "stripe" },
    { name: "Paypal", value: "paypal" },
  ];

  payment = {
    name: "",
    type: "paypal",
    enabled: true,
    publicKey: "",
    secretKey: "",
    policy: {
      refund: "",
      privacy: "",
      shipping: "",
      terms: "",
      faqs: "",
      aboutUs: "",
      dmca: "",
      cancelAndOrderChange: "",
      paymentMethod: "",
    },
    _id: "",
  };

  resetContent = false;

  mounted() {
    this.paymentId = this.$route.params.id || "";
    if (this.paymentId) {
      this.onGetDetail();
    }
  }

  async onGetDetail() {
    try {
      const response = await this.$api.payment.detail(this.paymentId);
      if (response?.data) {
        this.paymentDetail = response.data;
        this.payment = {
          ...response.data,
          policy: response.data.policyId || {
            refund: "",
            privacy: "",
            shipping: "",
            terms: "",
            faqs: "",
            aboutUs: "",
            dmca: "",
            cancelAndOrderChange: "",
            paymentMethod: "",
          },
        };
      }
    } catch (error) {
      apiErrorHandler(error, this);
    }
  }

  async onDeletePayment() {
    try {
      this.loadingDelete = true;
      await this.$api.payment.delete(this.paymentId);
      this.$pushNotification.success("Delete payment successfully");
      this.$router.push("/admin/settings/payment-method");
    } catch (error) {
      apiErrorHandler(error, this);
    } finally {
      this.loadingDelete = false;
    }
  }

  async onSave() {
    try {
      this.loading = true;
      let payment = cloneDeep(this.payment);
      if (payment.publicKey.includes("****")) {
        //@ts-ignore
        delete payment.publicKey;
      }
      if (payment.secretKey.includes("****")) {
        //@ts-ignore
        delete payment.secretKey;
      }
      await this.$api.payment.update(payment._id, payment);
      this.$pushNotification.success("Update payment settings successfully");
      this.onGetDetail();
    } catch (error) {
      apiErrorHandler(error, this);
    } finally {
      this.loading = false;
    }
  }

  get initEditor() {
    return {
      height: 400,
      image_title: true,
      automatic_uploads: true,
      //@ts-ignore
      file_picker_callback: function (cb, value, meta) {
        var input = document.createElement("input");
        input.setAttribute("type", "file");
        input.setAttribute("accept", "image/*");
        input.onchange = function () {
          //@ts-ignore
          var file = this.files[0];

          var reader = new FileReader();
          reader.onload = function () {
            var id = "blobid" + new Date().getTime();
            var blobCache =
              //@ts-ignore
              tinymce.activeEditor.editorUpload.blobCache;
            //@ts-ignore
            var base64 = reader.result.split(",")[1];
            var blobInfo = blobCache.create(id, file, base64);
            blobCache.add(blobInfo);
            cb(blobInfo.blobUri(), { title: file.name });
          };
          reader.readAsDataURL(file);
        };

        input.click();
      },
      file_picker_types: "image",
      plugins: ["lists link image code help wordcount"],
      toolbar:
        "undo redo | formatselect | bold italic | forecolor alignleft aligncenter alignright alignjustify | bullist numlist outdent indent | image link media template codesample inserttable | charmap emoticons hr | pagebreak nonbreaking anchor toc | insertdatetime | help",
    };
  }
}
</script>

<style></style>
